/*=======================================

	cMyError::Header File
	
	By Matt Barnett;

	Description: Simple error reporting.

	Usage:

		cMyError cMyError1;

		//quiet error printf()
		cMyError1.Error("vertex number %i is %s",vertex,stringproblem);

		//message box and printf()
		//same as FatalError(); except it doesnt look so intimidating
		cMyError1.AlertError("feature not supported %s",stringfeature);

		//call this to report a fatal error
		//just before you exit(-1);
		cMyError1.FatalError("Couldnt find file %s",stringlostfile);
		exit(-1);
		

=======================================*/

#ifndef		_MYERROR_CLASS_H
#define		_MYERROR_CLASS_H


#include	<windows.h>							//comment for non Win32 platforms


#include	<cstdio>							//for printf

//#define VERBOSE_CREATION						//class debug


class cMyError
{
	public:							
			
		cMyError();											//constructor
		~cMyError();										//destructon

		void FatalError(const char *strString, ...);		//MessageBox and printf()
		void AlertError(const char *strString, ...);		//exactly the same as FatalError (except title)
		void Error(const char *strString, ...);				//printf()		
		void Alert(const char *strString, ...);
		void Log(const char *strString, ...);

		static void isFlowHere(const char *filename, int linenumber)
		{
			printf("Program flow reached %s %i\n",filename,linenumber);
		}

		//static bool logall;
};

//macros are shouted and they use a ; so the usage is ...
//
//	CMYERROR_ISFLOWHERE
//  and not CMYERROR_ISFLOWHERE;
//
//which helps make it clear that its a macro we're calling
//

#define CMYERROR_ISFLOWHERE cMyError::isFlowHere(__FILE__,__LINE__);

#endif